/**
 * 
 */
package agms;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;



/**
 * @author developer@agms.com
 * @company AGMS
 * @date 7/25/2013
 */
public class Agms {
	private String transaction_type;
	private String payment_type;
	private String gateway_username = "";
	private String gateway_password = "";
	private String error_message = "";
	
	private double amount = 0;
	
	private String tax = "";
	private String shipping = "";
	private String order_description = "";
	private String order_id = "";
	private String po_number = "";
	private String cc_number = "";
	private String cc_exp_date = "";
	private String cc_cvv2 = "";
	private String check_name = "";
	private String check_aba = "";
	private String check_account = "";
	private String account_holder_type = "";
	private String account_type = "";
	private String sec_code = "";
	
	public boolean error_occurred = false;
	
	private String first_name = "";
	private String last_name = "";
	private String company = "";
	private String address1 = "";
	private String address2 = "";
	private String city = "";
	private String state = "";
	private String zip = "";
	private String country = "";
	private String phone = "";
	private String fax = "";
	private String email = "";
	private String website = "";
	
	private String shipping_first_name = "";
	private String shipping_last_name = "";
	private String shipping_company = "";
	private String shipping_address1 = "";
	private String shipping_address2 = "";
	private String shipping_city = "";
	private String shipping_state = "";
	private String shipping_zip = "";
	private String shipping_country = "";
	private String shipping_email = "";
	
	private String processor_id = "";
	private String transaction_id = "";
	private String tracking_number = "";
	private String shipping_carrier = "";
	private String ip_address = "";
	private String track1 = "";
	private String track2 = "";
	private String track3 = "";
	
	
	private String[] Custom_Field = {""};
	
	private String SAFE_Action = "";
	private String SAFE_ID = "";
	private String payment_plan_sku = "";
	
	private String force_code = "";
	private String recurring_start_date = "";
	
	private String full_xml_response = "";
	
	private String status_code = "";
	private String status_msg = "";
	private String trans_id = "";
	private String auth_code = "";
	private String avs_code = "";
	private String avs_msg = "";
	private String cvv2_code = "";
	private String cvv2_msg = "";
	private String orderid = "";
	private String SafeID = "";
	private String fullresponse = "";
	private String poststring = "";
	
	//transaction type
	public final String SALE = "sale";
	public final String AUTH = "auth";
	public final String CAPTURE = "capture";
	public final String VOID = "void";
	public final String REFUND = "refund";
	public final String UPDATE = "update";
	public final String OFFLINE = "offline";
	public final String VALIDATE = "validate";
	public final String ADD_RECURRING = "add_recurring";
	public final String DELETE_RECURRING = "delete_recurring";
	
	//payment type
	public final String CREDITCARD = "creditcard";
	public final String CHECK = "check";
	
	//account holder type
	public final String PERSONAL = "personal";
	public final String BUSINESS = "business";
	
	//acount type
	public final String SAVINGS = "savings";
	public final String CHECKING = "checking";
	
	//sec code
	public final String PPD = "PPD";
	public final String WEB = "WEB";
	public final String TEL = "TEL";
	public final String CCD = "CCD";
	
	public final String ADD_CUSTOMER = "add_customer";
	public final String DELETE_CUSTOMER = "delete_customer";
	public final String UPDATE_CUSTOMER = "update_customer";
	
	private static final String URL = "https://gateway.agms.com/roxapi/agms.asmx";
	
	/**
     * Default Constructor
	 */
	public Agms() {

   
	}
	
	  /** Set Gateway Username
	  *
	  * @param gateway_username
	  * Set the gatewayusername to the client's account
	  * You can use "AGMSintegration" for a demo account
	  */
	  public void setGatewayUsername(String gateway_username) {
		  this.gateway_username = gateway_username;
	    }
	  
	  /** Get Gateway Username
	   * 
	   * @return gateway_username
	   */
	  public String getGatewayUsername() {
			return gateway_username;
		}
	  
	  /** Set Gateway Password
	   * 
	   * @param gateway_password 
	   * Set the gatewaypassword to the client's account
	   * Please call 866-513-1547 for demo password.
	   */
	  public void setGatewayPassword(String gateway_password) {
			  this.gateway_password = gateway_password;
		}
	 
	  /** Get Gateway Password
	   * 
	   * @return gateway_password
	   */
	  public String getGatewayPassword() {
			return gateway_password;
		}
	  
	  /** Get Error Message
	   * Return any Error Messages during object creation
       * @return error_message
	   */
	  public String getErrorMessage() {
			return error_message;
		}
	  
	  /** Has Error Occurred
	   * Determines if an error has occurred in the object creation
	   * @return error_occurred
	   */
	   public boolean HasErrorOccurred() {
		   if (!(this.error_message.equals(""))){
			   
			   error_occurred = true;
			   return error_occurred;
			   
		   } else{
			   
			  error_occurred = false;
		   	  return error_occurred;
		   }
			
	   }
	  
	  /** Set Transaction Type
	   * @param transaction_type
	   * Transaction type must be one of the following values
	   * sale,auth,capture,void,refund,update,offline,validate,add_recurring,delete_recurring
	   */
	  public void setTransactionType(String transaction_type) {
		  if ((transaction_type.equalsIgnoreCase(SALE)) || (transaction_type.equalsIgnoreCase(AUTH)) || (transaction_type.equalsIgnoreCase(CAPTURE)) || (transaction_type.equalsIgnoreCase(VOID)) || (transaction_type.equalsIgnoreCase(REFUND)) || (transaction_type.equalsIgnoreCase(UPDATE)) || (transaction_type.equalsIgnoreCase(OFFLINE)) || (transaction_type.equalsIgnoreCase(VALIDATE)) || (transaction_type.equalsIgnoreCase(ADD_RECURRING)) || (transaction_type.equalsIgnoreCase(DELETE_RECURRING)) ) {
			    this.transaction_type = transaction_type;
		  } else {
			    error_message += "Transaction type must be one of the following: \nsale,auth,capture,void,refund,update,offline,validate,add_recurring,delete_recurring \n";
		  }
		
	    }
	  
	  /** Get Transaction Type
	  *  @return transaction_type
	  * 
	  */
	   public String getTransactionType() {
			return transaction_type;
		}
	   
      /** Set Payment Type
      * @param payment_type
	  * Payment type must be one of the following values
	  * sale,auth,capture,void,refund,update,offline,validate,add_recurring,delete_recurring
	  */
	   public void setPaymentType(String payment_type) {
		  if ((payment_type.equalsIgnoreCase(CREDITCARD)) || (payment_type.equalsIgnoreCase(CHECK)) ) {
			    this.payment_type = payment_type;
		  } else {
			    error_message += "Payment type must be one of the following: \ncreditcard, check \n";
		  }
			
		    }
	  
	  /** Get Payment Type
	  *  @return payment_type
	  * 
	  */
	   public String getPaymentType() {
			return payment_type;
		}
   
	   /** Set Amount for transaction
	     * @param amount 
		 * Amount must be numeric and greater then zero
		 * required for sale / auth
		 */
	   public void setAmount(double amount) {
		   this.amount = amount;
	   }
	   
		/** Get Amount
		 * @return amount
		 * 
		 */
	   public double getAmount() {
			return amount;
		}

	   /** Set Tax for transaction
	     * @param tax 
		 * Tax must be numeric and greater then zero
		 * not required
		 */
	   public void setTax(String tax) {
		   this.tax = tax;
	   }
	   
		/**  Get Tax
		 * @return tax
		 * 
		 */
	   public String getTax() {
			return tax;
		}
	   
	   /** Set Shipping for transaction
	    * @param shipping
		 * Tax must be numeric and greater then zero
		 * not required
		 */
	   public void setShipping(String shipping) {
		   this.shipping = shipping;
	   }
	   
		/**  Get Shipping
		 *  @return shipping
		 * 
		 */
	   public String getShipping() {
			return shipping;
		}
	   
	   /** Set Order Description
	    * @param order_description
		 * not required but recommended for sale / auth
		 * 
		 */
	   public void setOrderDescription(String order_description) {
		   this.order_description = order_description;
	   }
	   
		/** Get Order Description
		 * @return order_description
		 * 
		 */
	   public String getOrderDescription() {
			return order_description;
		}
	   
	   /** Set Order ID
	    * @param order_id
		 * not required but recommended
		 * 
		 */
	   public void setOrderID(String order_id) {
		   this.order_id = order_id;
	   }
	   
		/**  Get Order ID
		 *  @return order_id
		 * 
		 */
	   public String getOrderID() {
			return order_id;
		}
	   
	   /** Set PO Number
	    * @param po_number
		 * not required
		 * 
		 */
	   public void setPONumber(String po_number) {
		   this.po_number = po_number;
	   }
	   
		/** Get PO Number
		 * @return po_number
		 * 
		 */
	   public String getPONumber() {
			return po_number;
		}
	   
	   // CC TRANSACTION
	   /** Set CC Number
	    * @param cc_number
		 * Required for "sale" and "auth" if PaymentType="creditcard" and SAFE_ID not specified
		 * 
		 */
	   public void setCCNumber(String cc_number) {
		   this.cc_number = cc_number;
	   }
	   
		/** Get CC Number
		 * @return cc_number
		 * 
		 */
	   public String getCCNumber() {
			return cc_number;
		}
	   
	   /** Set CC Expiration date
	    * @param cc_exp_date
	    * Expiration date must be in the format MMYY
		 * Required for "sale" and "auth" if PaymentType="creditcard" and SAFE_ID not specified
		 * 
		 */
	   public void setCCExpDate(String cc_exp_date) {
		   this.cc_exp_date = cc_exp_date;
	   }
	   
		/** Get CC Expiration date
		 * @return cc_exp_date
		 * 
		 */
	   public String getCCExpDate() {
			return cc_exp_date;
		}
	   
	   /** Set CC cvv2
	    * @param cc_cvv2
		 * Required for "sale" and "auth" if PaymentType="creditcard" and SAFE_ID not specified
		 * 
		 */
	   public void setCvv2(String cc_cvv2) {
		   this.cc_cvv2 = cc_cvv2;
	   }
	   
		/** Get CC cvv2
		 * @return cc_cvv2
		 * 
		 */
	   public String getCvv2() {
			return cc_cvv2;
		}

	   // ACH TRANSACTION
	   /** Set Check Name 
	    * @param check_name
		 * Required for "sale" and "auth" if PaymentType="check" and SAFE_ID not specified
		 * 
		 */
	   public void setCheckName(String check_name) {
		   this.check_name = check_name;
	   }
	   
		/** Get Check Name
		 * @return check_name
		 * 
		 */
	   public String getCheckName() {
			return check_name;
		}
	   
	   /** Set Check ABA
	    * @param check_aba
		 * Required for "sale" and "auth" if PaymentType="check" and SAFE_ID not specified
		 * 
		 */
	   public void setCheckABA(String check_aba) {
		   this.check_aba = check_aba;
	   }
	   
		/** Get CheckABA
		 * @return check_aba
		 * 
		 */
	   public String getCheckABA() {
			return check_aba;
		}
	   
	   /** Set Check Account
	    * @param check_account
		 * Required for "sale" and "auth" if PaymentType="check" and SAFE_ID not specified
		 * 
		 */
	   public void setCheckAccount(String check_account) {
		   this.check_account = check_account;
	   }
	   
		/** Get Check Account
		 * @return check_account
		 * 
		 */
	   public String getCheckAccount() {
			return check_account;
		}
	   
	   /** Set Account Holder Type
	    * @param account_holder_type
		 * not required will default to personal if omitted
		 * business / personal
		 */
	   public void setAccountHolderType(String account_holder_type) {
		   
		  if ((account_holder_type.equalsIgnoreCase(PERSONAL)) || (account_holder_type.equalsIgnoreCase(BUSINESS)) ) {
			   this.account_holder_type = account_holder_type;
		  } else {
			    error_message += "Account holder type must be one of the following: \npersonal, business \n";
		  }
		
	   }
	   
		/** Get Account Holder Type
		 * @return account_holder_type
		 * 
		 */
	   public String getAccountHolderType() {
			return account_holder_type;
		}
	   
	   /** Set Account Type
	    * @param account_type
		 * not required will default to checking if omitted
		 * checking / savings
		 */
	   public void setAccountType(String account_type) {
		   
		  if ((account_type.equalsIgnoreCase(CHECKING)) || (account_type.equalsIgnoreCase(SAVINGS)) ) {
			  this.account_type = account_type;
		  } else {
			  error_message += "Account type must be one of the following: \nchecking, savings \n";
		  }
		 
	   }
	   
		/** Get Account Type
		 * @return account_type
		 * 
		 */
	   public String getAccountType() {
			return account_type;
		}
	   
	   /** Set SEC Code
	    * @param sec_code
		 * Required for "sale" and "auth" if PaymentType="check" and SAFE_ID not specified
		 * PPD / WEB / TEL / CCD
		 */
	   public void setSECCode(String sec_code) {
		   
		  if ((sec_code.equalsIgnoreCase(PPD)) || (sec_code.equalsIgnoreCase(WEB)) || (sec_code.equalsIgnoreCase(TEL)) || (sec_code.contentEquals(CCD)) ) {
			  this.sec_code = sec_code;
		  } else {
			  error_message += "Account type must be one of the following: \nchecking, savings \n";
		  }
		 
	   }
	   
		/** Get SEC Code
		 * @return sec_code
		 * 
		 */
	   public String getSECCode() {
			return sec_code;
		}

		/** Set First name
		 * @param first_name
		 * Recommend 
		 */
		public void setFirst_name(String first_name) {
			this.first_name = first_name;
		}

		/** Get First name
		 * @return first_name
		 */
		public String getFirst_name() {
			return first_name;
		}

		/** Set Last name
		 * @param last_name 
		 * Recommend 
		 */
		public void setLast_name(String last_name) {
			this.last_name = last_name;
		}

		/** Get Last name
		 * @return last_name
		 */
		public String getLast_name() {
			return last_name;
		}

		/** Set Company
		 * @param company 
		 * Recommend 
		 */
		public void setCompany(String company) {
			this.company = company;
		}

		/** Get Company
		 * @return company
		 */
		public String getCompany() {
			return company;
		}

		/** Set Address1
		 * @param address1 
		 */
		public void setAddress1(String address1) {
			this.address1 = address1;
		}

		/** Get Address1
		 * @return address1
		 */
		public String getAddress1() {
			return address1;
		}

		/** Set Address2
		 * @param address2 
		 */
		public void setAddress2(String address2) {
			this.address2 = address2;
		}

		/** Get Address2
		 * @return address2
		 */
		public String getAddress2() {
			return address2;
		}

		/** Set City
		 * @param city 
		 * Recommend 
		 */
		public void setCity(String city) {
			this.city = city;
		}

		/** Get City
		 * @return city
		 */
		public String getCity() {
			return city;
		}

		/** Set State
		 * @param state
		 * Recommend 
		 */
		public void setState(String state) {
			this.state = state;
		}

		/** Get State
		 * @return state
		 */
		public String getState() {
			return state;
		}

		/** Set Zip
		 * @param zip
		 * Recommend 
		 */
		public void setZip(String zip) {
			this.zip = zip;
		}

		/** Get Zip
		 * @return zip
		 */
		public String getZip() {
			return zip;
		}

		/** Set Country
		 * @param country
		 * 
		 */
		public void setCountry(String country) {
			this.country = country;
		}

		/** Get Country
		 * @return country
		 */
		public String getCountry() {
			return country;
		}

		/** Set Phone
		 * @param phone
		 * Recommend 
		 */
		public void setPhone(String phone) {
			this.phone = phone;
		}

		/** Get Phone
		 * @return phone
		 */
		public String getPhone() {
			return phone;
		}

		/** Set Fax
		 * @param fax
		 */
		public void setFax(String fax) {
			this.fax = fax;
		}

		/** Get Fax
		 * @return fax
		 */
		public String getFax() {
			return fax;
		}

		/** Set Email
		 * @param email
		 * Recommended
		 */
		public void setEmail(String email) {
			this.email = email;
		}

		/** Get Email
		 * @return email
		 */
		public String getEmail() {
			return email;
		}

		/** Set Website
		 * @param website
		 */
		public void setWebsite(String website) {
			this.website = website;
		}

		/** Get Website
		 * @return website
		 */
		public String getWebsite() {
			return website;
		}

		/** Set Shipping First Name
		 * @param shipping_first_name
		 */
		public void setShipping_first_name(String shipping_first_name) {
			this.shipping_first_name = shipping_first_name;
		}

		/** Get Shipping First Name
		 * @return shipping_first_name
		 */
		public String getShipping_first_name() {
			return shipping_first_name;
		}

		/** Set Shipping Last Name
		 * @param shipping_last_name
		 */
		public void setShipping_last_name(String shipping_last_name) {
			this.shipping_last_name = shipping_last_name;
		}

		/** Get Shipping Last Name
		 * @return shipping_last_name
		 */
		public String getShipping_last_name() {
			return shipping_last_name;
		}

		/** Set Shipping Company
		 * @param shipping_company
		 */
		public void setShipping_company(String shipping_company) {
			this.shipping_company = shipping_company;
		}

		/** Get Shipping Company
		 * @return shipping_company
		 */
		public String getShipping_company() {
			return shipping_company;
		}

		/** Set Shipping Address 1
		 * @param shipping_address1
		 */
		public void setShipping_address1(String shipping_address1) {
			this.shipping_address1 = shipping_address1;
		}

		/** Get Shipping Address 1
		 * @return shipping_address1
		 */
		public String getShipping_address1() {
			return shipping_address1;
		}

		/** Set Shipping Address 2
		 * @param shipping_address2
		 */
		public void setShipping_address2(String shipping_address2) {
			this.shipping_address2 = shipping_address2;
		}

		/** Get Shipping Address 2
		 * @return shipping_address2
		 */
		public String getShipping_address2() {
			return shipping_address2;
		}

		/** Set Shipping City
		 * @param shipping_city
		 */
		public void setShipping_city(String shipping_city) {
			this.shipping_city = shipping_city;
		}

		/** Get Shipping City
		 * @return shipping_city
		 */
		public String getShipping_city() {
			return shipping_city;
		}

		/** Set Shipping State
		 * @param shipping_state
		 */
		public void setShipping_state(String shipping_state) {
			this.shipping_state = shipping_state;
		}

		/** Get Shipping State
		 * @return shipping_state
		 */
		public String getShipping_state() {
			return shipping_state;
		}

		/** Set Shipping Zip
		 * @param shipping_zip
		 */
		public void setShipping_zip(String shipping_zip) {
			this.shipping_zip = shipping_zip;
		}

		/** Get Shipping Zip
		 * @return shipping_zip
		 */
		public String getShipping_zip() {
			return shipping_zip;
		}

		/** Set Shipping Country
		 * @param shipping_country
		 */
		public void setShipping_country(String shipping_country) {
			this.shipping_country = shipping_country;
		}

		/** Get Shipping Country
		 * @return shipping_country
		 */
		public String getShipping_country() {
			return shipping_country;
		}

		/** Set Shipping Email
		 * @param shipping_email
		 */
		public void setShipping_email(String shipping_email) {
			this.shipping_email = shipping_email;
		}

		/** Get Shipping Email
		 * @return shipping_email
		 */
		public String getShipping_email() {
			return shipping_email;
		}

		/** Set Processor ID
		 * If multiple Merchant Accounts used with a single gateway account, use this to specify which Account to use.
		 * @param processor_id
		 */
		public void setProcessor_id(String processor_id) {
			this.processor_id = processor_id;
		}

		/** Get Processor ID
		 * @return processor_id
		 */
		public String getProcessor_id() {
			return processor_id;
		}
		
		/** Set Transaction ID
		 * Required for TransactionType = "capture", "refund", "void", "update" or "delete_recurring"
		 * @param transaction_id
		 */
		public void setTransaction_id(String transaction_id) {
			this.transaction_id = transaction_id;
		}

		/** Get Transaction ID
		 * @return transaction_id
		 */
		public String getTransaction_id() {
			return transaction_id;
		}

		/** Set Tracking Number
		 * 
		 * @param tracking_number
		 */
		public void setTracking_number(String tracking_number) {
			this.tracking_number = tracking_number;
		}

		/** Get Tracking Number
		 * @return tracking_number
		 */
		public String getTracking_number() {
			return tracking_number;
		}

		/** Set Shipping Carrier
		 * @param shipping_carrier
		 */
		public void setShipping_carrier(String shipping_carrier) {
			this.shipping_carrier = shipping_carrier;
		}

		/** Get Shipping Carrier
		 * @return shipping_carrier
		 */
		public String getShipping_carrier() {
			return shipping_carrier;
		}

		/** Set IP Address
		 * @param ip_address
		 */
		public void setIp_address(String ip_address) {
			this.ip_address = ip_address;
		}

		/** Get IP Address
		 * @return ip_address
		 */
		public String getIp_address() {
			return ip_address;
		}

		/** Set Track 1
		 *  For swipe support
		 * @param track1
		 */
		public void setTrack1(String track1) {
			this.track1 = track1;
		}

		/** Get Track 1
		 * @return track1
		 */
		public String getTrack1() {
			return track1;
		}

		/** Set Track 2
		 * For swipe support
		 * @param track2
		 */
		public void setTrack2(String track2) {
			this.track2 = track2;
		}

		/** Get Track 2
		 * @return track2
		 */
		public String getTrack2() {
			return track2;
		}

		/** Set Track 3
		 * For swipe support
		 * @param track3
		 */
		public void setTrack3(String track3) {
			this.track3 = track3;
		}

		/** Get Track 3
		 * @return track3
		 */
		public String getTrack3() {
			return track3;
		}

		/** Set Safe Action
		 * used with add_customer, update_customer, delete_customer
		 * Required if TransactionType is omitted
		 * @param SAFE_Action
		 */
		public void setSAFE_Action(String SAFE_Action) {
			this.SAFE_Action = SAFE_Action;
		}

		
		/** Get Safe Action
		 * @return SAFE_Action
		 */
		public String getSAFE_Action() {
			return SAFE_Action;
		}

		
		/** Set Safe ID
		 * required for SAFE_Action = "update_customer" or "delete_customer"
		 * @param SAFE_ID
		 */
		public void setSAFE_ID(String SAFE_ID) {
			this.SAFE_ID = SAFE_ID;
		}

		
		/** Get Safe ID
		 * @return SAFE_ID
		 */
		public String getSAFE_ID() {
			return SAFE_ID;
		}

		
		/** Set Payment Plan SKU
		 * Payment Plans can be setup in the gateway. These are recurring billing plans. An SKU is specified when setting up the plan.
		 * Pass this SKU here to sign this customer up for the payment plan.
		 * @param payment_plan_sku
		 */
		public void setPayment_plan_sku(String payment_plan_sku) {
			this.payment_plan_sku = payment_plan_sku;
		}

		
		/** Get Payment Plan SKU
		 * @return payment_plan_sku
		 */
		public String getPayment_plan_sku() {
			return payment_plan_sku;
		}

		
		/** Set Force Code
		 *  not required. Used for "offline" transactions
		 * @param force_code
		 */
		public void setForce_code(String force_code) {
			this.force_code = force_code;
		}

		
		/** Get Force Code
		 * @return force_code
		 */
		public String getForce_code() {
			return force_code;
		}

		
		/** Set Recurring Start Date
		 * Only used for TransactionType = "add_recurring"
		 * @param recurring_start_date
		 */
		public void setRecurring_start_date(String recurring_start_date) {
			this.recurring_start_date = recurring_start_date;
		}

		/** Get Recurring Start Date
		 * @return recurring_start_date
		 */
		public String getRecurring_start_date() {
			return recurring_start_date;
		}

		/**
		 * Build XML 
		 * This function will build the XML blob needed for this transaction based on the provided values
		 * @return XML Body for this transaction
		 */
		 public String BuildXML() {
			 if (!(this.gateway_username.contentEquals("")) && !(this.gateway_password.contentEquals(""))) {
				 
					   String vString;
				    	
				    	vString = "";
				    	
				    	vString = vString + "<TransactionType>" + this.transaction_type + "</TransactionType>";
				    	vString = vString + "<GatewayUserName>" + this.gateway_username + "</GatewayUserName>";
				    	vString = vString + "<GatewayPassword>" + this.gateway_password + "</GatewayPassword>";
				    	
				    	if (this.transaction_type.equals("void")) {
				    		 vString = vString + "<TransactionID>" + this.transaction_id + "</TransactionID>";
				    		 if (this.payment_type == "check") {
				    			 vString = vString + "<PaymentType>" + this.payment_type + "</PaymentType>"; 
				    		 }
				    	}
				    	
				    	if (this.transaction_type.equals("refund")) {
				    		vString = vString + "<Amount>" + this.amount + "</Amount>"; 
				    		vString = vString + "<TransactionID>" + this.transaction_id + "</TransactionID>"; 
				    		
				    		if (this.payment_type.equals("check")) {
				    			vString = vString + "<PaymentType>" + this.payment_type + "</PaymentType>"; 
				    		}
				    	}
				    	
				    	if (this.transaction_type.equals("capture") ) {
				    	    vString = vString + "<Amount>" + this.amount + "</Amount>";
				   	        vString = vString + "<TransactionID>" + this.transaction_id + "</TransactionID>"; 
				   	        vString = vString + "<OrderID>" + this.order_id + "</OrderID>";     	        
				   	        vString = vString + "<Tracking_Number>" + this.tracking_number + "</Tracking_Number>"; 
				   	        vString = vString + "<Shipping_Carrier>" + this.shipping_carrier + "</Shipping_Carrier>"; 
				    	
				   	        if (this.payment_type.equals("check")){
				   	        	vString = vString + "<PaymentType>" + this.payment_type + "</PaymentType>"; 
				   	        }
				    	}
				    	
				    	if (this.transaction_type.equals("update")) {
				    		 vString = vString + "<TransactionID>" + this.transaction_id + "</TransactionID>"; 
				    		 vString = vString + "<Tracking_Number>" + this.tracking_number + "</Tracking_Number>"; 
				    		 vString = vString + "<Shipping_Carrier>" + this.shipping_carrier + "</Shipping_Carrier>"; 
				    		 
				    		 if (this.payment_type.equals("check")){
				    	        	vString = vString + "<PaymentType>" + this.payment_type + "</PaymentType>"; 
				    	        }
				    	}
				    	
				    	if (this.SAFE_Action.equals("delete_customer")) {
				    		vString = vString + "<SAFE_Action>" + this.SAFE_Action + "</SAFE_Action>";
				    		vString = vString + "<SAFE_ID>" + this.SAFE_ID + "</SAFE_ID>"; 
				    	}
				    	
				    	if (this.transaction_type.equals("sale") || this.transaction_type.equals("auth") || this.SAFE_Action.equals("add_customer") || this.SAFE_Action.equals("update_customer")) {
				    		vString = vString + "<PaymentType>" + this.payment_type + "</PaymentType>";
				    		if (this.SAFE_Action.equals("add_customer") || this.SAFE_Action.equals("update_customer")) {
				    			vString = vString + "<SAFE_Action>" + this.SAFE_Action + "</SAFE_Action>"; 
				    		}
				    		vString = vString + "<SAFE_ID>" + this.SAFE_ID + "</SAFE_ID>"; 
				    		if (this.payment_type.equals("creditcard")){
				    			 vString = vString + "<CCNumber>" + this.cc_number + "</CCNumber>"; 
				    			 vString = vString + "<CCExpDate>" + this.cc_exp_date + "</CCExpDate>"; 
				    			 vString = vString + "<CVV>" + this.cc_cvv2 + "</CVV>"; 
				    		}
				    		if (this.payment_type.equals("check")){
				    			vString = vString + "<CheckName>" + this.check_name + "</CheckName>"; 
				                vString = vString + "<CheckABA>" + this.check_aba + "</CheckABA>"; 
				                vString = vString + "<CheckAccount>" + this.check_account + "</CheckAccount>"; 
				                vString = vString + "<AccountHolderType>" + this.account_holder_type + "</AccountHolderType>"; 
				                vString = vString + "<AccountType>" + this.account_type + "</AccountType>";
				                vString = vString + "<SecCode>" + this.sec_code + "</SecCode>"; 
				    		}
				    		
				    		  vString = vString + "<Payment_Plan_SKU>" + this.payment_plan_sku + "</Payment_Plan_SKU>"; 
				    		  
				              vString = vString + "<Amount>" + this.amount + "</Amount>"; 
					          vString = vString + "<Tax>" + this.tax + "</Tax>"; 
					          vString = vString + "<Shipping>" + this.shipping + "</Shipping>"; 
					          vString = vString + "<OrderDescription>" + this.order_description + "</OrderDescription>"; 
					          vString = vString + "<OrderID>" + this.order_id + "</OrderID>"; 
					          vString = vString + "<PONumber>" + this.po_number + "</PONumber>";
				  
					          vString = vString + "<FirstName>" + this.first_name + "</FirstName>"; 
					          vString = vString + "<LastName>" + this.last_name + "</LastName>"; 
					          vString = vString + "<Company>" + this.company + "</Company>"; 
					          vString = vString + "<Address1>" + this.address1 + "</Address1>";     		          
					          vString = vString + "<Address2>" + this.address2 + "</Address2>"; 
					          vString = vString + "<City>" + this.city + "</City>"; 
					          vString = vString + "<State>" + this.state + "</State>"; 
					          vString = vString + "<Zip>" + this.zip + "</Zip>"; 
					          vString = vString + "<Country>" + this.country + "</Country>"; 
					          vString = vString + "<Phone>" + this.phone + "</Phone>"; 
					          vString = vString + "<Fax>" + this.fax + "</Fax>"; 
				              vString = vString + "<EMail>" + this.email + "</EMail>"; 
					          vString = vString + "<Website>" + this.website + "</Website>"; 
					  
					          vString = vString + "<ShippingFirstName>" + this.shipping_first_name + "</ShippingFirstName>"; 
					          vString = vString + "<ShippingLastName>" + this.shipping_last_name + "</ShippingLastName>"; 
					          vString = vString + "<ShippingCompany>" + this.shipping_company + "</ShippingCompany>"; 
					          vString = vString + "<ShippingAddress1>" + this.shipping_address1 + "</ShippingAddress1>"; 
					          vString = vString + "<ShippingAddress2>" + this.shipping_address2 + "</ShippingAddress2>"; 
					          vString = vString + "<ShippingCity>" + this.shipping_city + "</ShippingCity>"; 
					          vString = vString + "<ShippingState>" + this.shipping_state + "</ShippingState>"; 
					          vString = vString + "<ShippingZip>" + this.shipping_zip + "</ShippingZip>"; 
					          vString = vString + "<ShippingCountry>" + this.shipping_country + "</ShippingCountry>"; 
					          vString = vString + "<ShippingEmail>" + this.shipping_email + "</ShippingEmail>"; 
					 
					          vString = vString + "<ProcessorID>" + this.processor_id + "</ProcessorID>"; 
					          
					          
					          //return custom fields function instead
					          String vMDFs = "";
					          
					          if (!(this.Custom_Field.equals(null))){
					        	  if (!(this.Custom_Field.equals(""))){
					        		  vMDFs = this.Return_Custom_Field(this.Custom_Field);
						        	  vString = vString + vMDFs;
					        	  }
					          }
					       
					          
				    	}
				 
				    	return vString;
				    	
			 	} else {
			 		this.error_message += "You must supply a gateway username and gateway password in order to process a transaction";
			 		return "";
			 	}
			 		
		    }
		 /**
		  * Return custom Field xml
		  * @param String[]
		  * @returns String
		  * used to append the custom fields to the xml request
		  */
		 private String Return_Custom_Field(String vMDFields[]) {
			 
			String vReturnFields = "";
			int field_number = 0;
			
	        if (vMDFields.length > 0) {
	        	for (int i = 0; i < vMDFields.length; i++) {
	        		if (!(vMDFields[i].equals(null))) {
	        			if (i <=  19){
	        	 			field_number = i + 1;
							vReturnFields += "<Custom_Field_" + field_number + ">" + vMDFields[i] + "</Custom_Field_" + field_number + ">";
	        			}
					}
	        	}
	        } else {
	        	return vReturnFields;
	        }
	        
	        return vReturnFields;

		 }
		 /**
		  * Post Transaction
		  * the only parameter is the soapless xml blob. Soap wrapper is added in this function and not needed before passing it in
		  * @param vBody
		  */
		  public void PostTransaction(String vBody) {
				 
			  try {
				  
				    String xmldata = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
				"<soap:Envelope " +
				  "xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
				  "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" " +
				  "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">" +
			          "<soap:Body>" +
				    "<ProcessTransaction xmlns=\"https://gateway.agms.com/roxapi/\">" +
				      "<objparameters>" +
				      vBody +
		   		      "</objparameters>" +
				   "</ProcessTransaction>" +
				  "</soap:Body>" +
			        "</soap:Envelope>";
			  
					@SuppressWarnings("unused")
					HostnameVerifier hostnameVerifier = new HostnameVerifier() {
					
						public boolean verify(String hostname, SSLSession session) {
							return true;
						}
					};
					
					trustAllHosts();
				    String urlString = URL;
				    URL url = new URL(urlString); 

			        HttpsURLConnection httpURLConnection = (HttpsURLConnection) url.openConnection();
			       
			        if (!(httpURLConnection instanceof HttpURLConnection))                     
			            throw new IOException("Not an HTTP connection");

			     
			            HttpURLConnection httpConn = (HttpsURLConnection) httpURLConnection;
			            httpConn.setAllowUserInteraction(false);
			            httpConn.setInstanceFollowRedirects(true);
	    	
			    		InputStream is = new ByteArrayInputStream(xmldata.getBytes("UTF-8"));
			    		
			            ByteArrayOutputStream bout = new ByteArrayOutputStream();
			        
			            // Copy the SOAP file to the open connection.
			            copy(is,bout);
			          
			            is.close();
			            byte[] b = bout.toByteArray();

			            // Set the appropriate HTTP parameters.
			            httpConn.setRequestProperty( "Content-Length", String.valueOf(b.length));
			            httpConn.setRequestProperty("Content-Type","text/xml; charset=utf-8");
			            httpConn.setRequestMethod("POST");
			            httpConn.setDoOutput(true);
			            httpConn.setDoInput(true);

			            // Everything's set up; send the XML that was read in to b.
			            OutputStream out = httpConn.getOutputStream();
			            out.write(b);    
			            out.close();
			            
			            InputStreamReader isr = new InputStreamReader(httpConn.getInputStream());
			            BufferedReader in = new BufferedReader(isr);

			            String inputLine;
			            String XMLResults = null;
			            
			            while ((inputLine = in.readLine()) != null) {
			            	XMLResults = inputLine;
			            }
			            	
			              in.close();
			              
			             setResponse_Full_xml_response(XMLResults);
			    	     setResponse_Fullresponse(ExtractXMLElement(XMLResults,"FULLRESPONSE"));
			    	     setResponse_Status_code(ExtractXMLElement(XMLResults,"STATUS_CODE"));
			    	     setResponse_Status_msg(ExtractXMLElement(XMLResults,"STATUS_MSG"));
			    	     setResponse_Trans_id(ExtractXMLElement(XMLResults,"TRANS_ID"));
			    	     setResponse_Auth_code(ExtractXMLElement(XMLResults,"AUTH_CODE"));
			    	     setResponse_Avs_code(ExtractXMLElement(XMLResults,"AVS_CODE"));
			    	     setResponse_Avs_msg(ExtractXMLElement(XMLResults,"AVS_MSG"));
			    	     setResponse_Cvv2_code(ExtractXMLElement(XMLResults,"CVV2_CODE"));
			    	     setResponse_Cvv2_msg(ExtractXMLElement(XMLResults,"CVV2_MSG"));
			    	     setResponse_Orderid(ExtractXMLElement(XMLResults,"ORDERID"));
			    	     setResponse_SafeID(ExtractXMLElement(XMLResults,"SAFE_ID"));
			    	     setResponse_Poststring(ExtractXMLElement(XMLResults,"POSTSTRING"));

			  }catch (Exception e) {
				  error_message = e.getMessage();
				  System.out.print(error_message);
			  } 	
		
		  }
		  private static void copy(InputStream in, OutputStream out) 
		   throws IOException {

		    synchronized (in) {
		      synchronized (out) {

		        byte[] buffer = new byte[256];
		        while (true) {
		          int bytesRead = in.read(buffer);
		          if (bytesRead == -1) break;
		          out.write(buffer, 0, bytesRead);
		        }
		      }
		    }
		  }
		  
		  private String ExtractXMLElement(String vXML, String vElement) {
		    	int startpos = 0;
		    	int endpos = 0;
		    	int startlength = 0;
		    	String vValue;
		    	vValue = "";
		    	startlength = vElement.length() + 2;
		   
		    	startpos = vXML.indexOf("<" + vElement + ">", 1);
		    	
		    	if (startpos > 0) {
		    		startpos = startpos + startlength;
		    		endpos = vXML.indexOf("</" + vElement + ">", 1);
		    		//endpos = endpos + endlength;
		    		vValue = vXML.substring(startpos,endpos);
		    	}
		    	
		    	return vValue;
		    	
		    }

		  /** 
			 * Trust every server - dont check for any certificate 
			 */ 
			private static void trustAllHosts() { 
				// Create a trust manager that does not validate certificate chains 
				TrustManager[] trustAllCerts = new TrustManager[] { new X509TrustManager() { 
					public java.security.cert.X509Certificate[] getAcceptedIssuers() { 
						return new java.security.cert.X509Certificate[] {}; 
					} 

					public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException { 
					} 

					public void checkServerTrusted(X509Certificate[] chain, String authType) throws CertificateException { 
					} 
				} }; 

				// Install the all-trusting trust manager 
				try { 
					SSLContext sc = SSLContext.getInstance("TLS");//("TLS"); 
					sc.init(null, trustAllCerts, new java.security.SecureRandom()); 
					HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory()); 
				
				} catch (Exception e) { 
					e.printStackTrace(); 
				} 
			}

		/** Set Full XML Response
		 * Set the full xml response to full_xml_response
		 * @param full_xml_response
		 */
		public void setResponse_Full_xml_response(String full_xml_response) {
			this.full_xml_response = full_xml_response;
		}

		/** Get Full XML Resposne
		 * This method can be used to retrieve the entire response in full soap xml
		 * that you can parse as you wish, you do not need to parse the results 
		 * if you don't want to
		 * @return full_xml_response
		 */
		public String getResponse_Full_xml_response() {
			return full_xml_response;
		}

		/** Set Status Code from Results
		 * @param status_code
		 */
		public void setResponse_Status_code(String status_code) {
			this.status_code = status_code;
		}

		/** Get Status Code from Results
		 *  1 = APPROVAL
		 *	2 = DECLINE
		 *	10 = VALIDATION ERROR
		 *	20 = DATA ERROR OR SYSTEM ERROR
		 *	30 = EXCEPTION
		 * @return status_code
		 */
		public String getResponse_Status_code() {
			return status_code;
		}

		/** Set Status MSG from Results
		 * @param status_msg
		 */
		public void setResponse_Status_msg(String status_msg) {
			this.status_msg = status_msg;
		}

		/** Get Status msg from Results
		 * Text Description of status_code
		 * @return status_msg
		 */
		public String getResponse_Status_msg() {
			return status_msg;
		}

		/** Set Transaction ID from Results
		 * @param trans_id 
		 */
		public void setResponse_Trans_id(String trans_id) {
			this.trans_id = trans_id;
		}

		/** Get Transaction ID from Results
		 * Transaction ID of completed transaction. Returned when any transaction_type is
		 * used and the transaction is successful
		 * @return the trans_id
		 */
		public String getResponse_Trans_id() {
			return trans_id;
		}

		/** Set Auth Code from Results
		 * @param auth_code
		 */
		public void setResponse_Auth_code(String auth_code) {
			this.auth_code = auth_code;
		}

		/** Get Auth Code from Results
		 * Transaction Authorization Code
		 * @return auth_code
		 */
		public String getResponse_Auth_code() {
			return auth_code;
		}

		/** Set AVS Code from Results
		 * @param avs_code
		 */
		public void setResponse_Avs_code(String avs_code) {
			this.avs_code = avs_code;
		}

		/** Get AVS Code from Results
		 *  Y, D or M = Exact Match, 5-character numeric ZIP
		 *	A or B = Address match only
		 *	W = 9 character numeric ZIP match only
		 *	Z, P or L = 5 character numeric ZIP match only
		 *	N or C = No Address or ZIP match
		 *	U = Address unavailable
		 *	G or I = Non-U.S. Issuer does not participate
		 *	R = Issuer system unavailable
		 *	E = Not a mail/phone order
		 *	S = Service not supported
		 *	0, O or B = AVS Not Available
		 * @return avs_code
		 */
		public String getResponse_Avs_code() {
			return avs_code;
		}

		/** Set AVS Msg from Results
		 * @param avs_msg
		 */
		public void setResponse_Avs_msg(String avs_msg) {
			this.avs_msg = avs_msg;
		}

		/** Get AVS Msg from Results
		 * Text Description of AVS_CODE
		 * @return avs_msg
		 */
		public String getResponse_Avs_msg() {
			return avs_msg;
		}

		/** Set CVV2 Code from Results
		 * @param cvv2_code
		 */
		public void setResponse_Cvv2_code(String cvv2_code) {
			this.cvv2_code = cvv2_code;
		}

		/** Get CVV2 Code from Results
		 *  M = CVV2/CVC2 Match
		 *	N = CVV2/CVC2 No Match
		 *	P = Not Processed
		 *	S = Merchant has indicated that CVV2/CVC2 is not present on card
		 *	U = Issuer is not certified and/or has not provided Visa encryption keys
		 * @return cvv2_code
		 */
		public String getResponse_Cvv2_code() {
			return cvv2_code;
		}

		/** Set CVV2 Msg from Results
		 * @param cvv2_msg
		 */
		public void setResponse_Cvv2_msg(String cvv2_msg) {
			this.cvv2_msg = cvv2_msg;
		}

		/**
		 * Get CVV2 Msg from Results
		 * Text Description of CVV2_CODE
		 * @return cvv2_msg
		 */
		public String getResponse_Cvv2_msg() {
			return cvv2_msg;
		}

		/** Set Order ID from Results
		 * @param orderid
		 */
		public void setResponse_Orderid(String orderid) {
			this.orderid = orderid;
		}

		/** Get Order ID from Results
		 * Return of OrderID passed in during request.
		 * @return orderid
		 */
		public String getResponse_Orderid() {
			return orderid;
		}

		/** Set Safe ID from Results
		 * @param SafeID
		 */
		public void setResponse_SafeID(String SafeID) {
			this.SafeID = SafeID;
		}

		/** Get Safe ID from Results
		 * If SAFE_Action used, the SAFE_ID will be returned
		 * @return SafeID
		 */
		public String getResponse_SafeID() {
			return SafeID;
		}

		/** Set Full Response from Results
		 * @param fullresponse
		 */
		public void setResponse_Fullresponse(String fullresponse) {
			this.fullresponse = fullresponse;
		}

		/** Get Full Response from Results
		 * Full response from gateway for troubleshooting purposes
		 * @return fullresponse
		 */
		public String getResponse_Fullresponse() {
			return fullresponse;
		}

		/** Set Post String from Results
	
		 * @param poststring
		 */
		public void setResponse_Poststring(String poststring) {
			this.poststring = poststring;
		}

		/** Get Post String from Results
		 * Full text request sent to gateway for troubleshooting purposes.
		 * @return poststring
		 */
		public String getResponse_Poststring() {
			return poststring;
		}

		/** Set custom Fields String Array
		 * custom Fields can be specified in the gateway and passed in here. Up to 20 are supported.
         * These can be anything that is useful for the merchant to track along with a transaction.
		 * @param Custom_Field
		 */
		public void setCustom_Field(
				String Custom_Field[]) {
			this.Custom_Field = Custom_Field;
		}

		/** Get custom Fields String Array
		 * @return String[]
		 */
		public String[] getCustom_Field() {
			return Custom_Field;
		}

}
