import agms.Agms;

public class GatewayTest {
	public static void main (String args[]){
		// Initialize a instance of the AGMSgateway object 
		Agms transaction = new Agms();
		    
		// Set the gateway credentials to process the transaction
		transaction.setGatewayUsername("your username");
		transaction.setGatewayPassword("your password");

		// Set the transaction type and the payment type.  Constants exist for each type 
		transaction.setTransactionType(transaction.SALE);
		transaction.setPaymentType(transaction.CREDITCARD);

		// Set a transaction id for a refund / capture. Not needed for a sale/auth
		transaction.setTransaction_id("1430963878");

		// Set amount for the current transaction (double)
		transaction.setAmount(118.50);

		// Set any additional fields for the transaction such as name, address, email, company
		transaction.setFirst_name("Tim");
		transaction.setLast_name("Tester");
		transaction.setAddress1("123 fake st");
		transaction.setAddress2("suite x");
		transaction.setCity("Schaumburg");
		transaction.setState("IL");
		transaction.setCountry("US");
		transaction.setZip("60060");
		transaction.setEmail("fake@fake.org");
		transaction.setPhone("8889990000");
		transaction.setFax("9998881111");
		transaction.setCompany("Test Company");

		// Set an order description will be transmitted to the gateway
		transaction.setOrderDescription("WIDGET");

		// Set an order id for any internal book keeping
		transaction.setOrderID("99292929838403");

		// Not required but you can set shipping values
		transaction.setShipping_address1("321 fakest st");
		transaction.setShipping_address2("suite xxxx");
		transaction.setShipping_city("Hoffman Estates");
		transaction.setShipping_email("fake@fake.com");
		transaction.setShipping_zip("33309");
		transaction.setShipping_first_name("John");
		transaction.setShipping_last_name("Doe");
		transaction.setShipping_state("IL");
		transaction.setShipping_country("US");

		// Set the credit card information
		transaction.setCCNumber("4111111111111111");
		transaction.setCCExpDate("1220");
		transaction.setCvv2("123");

		// Set a customer vault action to vault the customer purchasing the item
		// Not required but could be useful for future transction processing
		// transaction.setCustomer_vault_action(transaction.ADD_CUSTOMER);
		        
		// Call BuildXML to build the XML string based on the values supplied above
		String vBody;
		vBody = transaction.BuildXML();

		// Check for any errors
		transaction.error_occurred = transaction.HasErrorOccurred();

		if (transaction.error_occurred) {
			System.out.println(transaction.getErrorMessage());

		} else {
			
			// No errors have occurred lets process this transaction
			transaction.PostTransaction(vBody);

			// Displaying the results
			System.out.println(vBody);
			System.out.println(transaction.getResponse_Auth_code());
			System.out.println(transaction.getResponse_Avs_code());
			System.out.println(transaction.getResponse_Avs_msg());
			// System.out.println(transaction.getResponse_Customervaultid());
			System.out.println(transaction.getResponse_Cvv2_code());
			System.out.println(transaction.getResponse_Cvv2_msg());
			System.out.println(transaction.getResponse_Full_xml_response());
			System.out.println(transaction.getResponse_Fullresponse());
			System.out.println(transaction.getResponse_Orderid());
			System.out.println(transaction.getResponse_Poststring());
			System.out.println(transaction.getResponse_Status_code());
			System.out.println(transaction.getResponse_Status_msg());
			System.out.println(transaction.getResponse_Trans_id());
			
		}
	}
}

